#ifndef FSM_H
#define FSM_H
#define adresseLcd 0x27
#include "ci2c.h"
#include "i2c_afficheur_4x20.h"
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <QtSql/QSqlDatabase>
#include <QtSql/QSqlQuery>
#include <QtSql/QSqlError>
#include <QDebug>



typedef enum{
    NILEVENT,
    EVENT_INIT,
    EVENT2,
    EVENT3,
    EVENT4,
    EVENT5,
    EVENT6,
    EVENT7,
    EVENT8,
    EVENT9,
    EVENT10,
    EVENT11,
    EVENT_FINAL
} event;

typedef enum{
    STATE_INIT,
    STATE2,
    STATE3,
    STATE4,
    STATE5,
    STATE6,
    STATE7,
    STATE8,
    STATE9,
    STATE10,
    STATE11,
    STATE_FINAL
} state;

typedef void (*action)();

typedef struct {
    state nextState;
    action actionToDo;
} stateElement;


class FSM
{
public:
	FSM();
	~FSM();


    state  currentState;


static void action_init(void);
static void action_2_1(void);
static void action_2_2(void);
static void action_2_3(void);
static void action_3_1(void);
static void action_3_2(void);
static void action_3_3(void);
static void action_4_1(void);
static void action_4_2(void);
static void action_4_3(void);
static void action_11(void);
static void action_final(void);

void stateEval(event e);
void exit(int status);
void getIOValues(void);



void fsmGest();
void openBDD();

static stateElement stateMatrix [3][3];

QSqlDatabase bdd;

QSqlError error;




};

#endif // FSM_H
