// inclusions des librairies
#include "ci2c.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <unistd.h>
#include <QString>

using namespace std;

#ifndef I2C_AFFICHEUR_4X20_H
#define I2C_AFFICHEUR_4X20_H

// commands
#define LCD_CLEARDISPLAY 0x01
#define LCD_RETURNHOME 0x02
#define LCD_ENTRYMODESET 0x04
#define LCD_DISPLAYCONTROL 0x08
#define LCD_CURSORSHIFT 0x10
#define LCD_FUNCTIONSET 0x20
#define LCD_SETCGRAMADDR 0x40
#define LCD_SETDDRAMADDR 0x80

// flags for display entry mode
#define LCD_ENTRYRIGHT 0x00
#define LCD_ENTRYLEFT 0x02
#define LCD_ENTRYSHIFTINCREMENT 0x01
#define LCD_ENTRYSHIFTDECREMENT 0x00

// flags for display on/off control
#define LCD_DISPLAYON 0x04
#define LCD_DISPLAYOFF 0x00
#define LCD_CURSORON 0x02
#define LCD_CURSOROFF 0x00
#define LCD_BLINKON 0x01
#define LCD_BLINKOFF 0x00

// flags for display/cursor shift
#define LCD_DISPLAYMOVE 0x08
#define LCD_CURSORMOVE 0x00
#define LCD_MOVERIGHT 0x04
#define LCD_MOVELEFT 0x00

// flags for function set
#define LCD_8BITMODE 0x10
#define LCD_4BITMODE 0x00
#define LCD_2LINE 0x08
#define LCD_1LINE 0x00
#define LCD_5x10DOTS 0x04
#define LCD_5x8DOTS 0x00

// flags for backlight control
#define LCD_BACKLIGHT 0x08
#define LCD_NOBACKLIGHT 0x00

#define En 0b00000100 // Enable bit
#define Rw 0b00000010 // Read/Write bit
#define Rs 0b00000001 // Register select bit

typedef unsigned char byte;

class I2C_Afficheur_4x20
{
public:
    I2C_Afficheur_4x20(int lcdAddress); // Constructeur de la classe avec comme parametre l'adresse de l'afficheur
    void lcdInit(); // Initialisation de l'afficheur
    void writeLcdDisplay(QString text, int line); // Ecrire sur l'afficheur avec comme parametre le texte et la ligne max 20 chars
    void lcdClear(); // Effacer et l'afficheur
    void displayOn(); // Backlight on
    void displayOff(); // Backlight off

// Declaration des attribues
private:
   byte enLight; // octet de backlight

   void write4bits(byte data);
   void wirteLcd(byte cmd, byte mode);
   void wirteStrob(byte data);
   void writeCmd(byte cmd);

   Ci2c *I2C; // Pointeur sur la class Ci2c
};

#endif // I2C_AFFICHEUR_4X20_H
