#ifndef DS3231_H
#define DS3231_H

#include <QString>
#include "ci2c.h"

typedef unsigned char byte;

class DS3231
{
public:
    DS3231(int addDS3231); // Constructeur de la classe DS3231 avec comme parametre l'adresse de la RTC

    byte readTemp(); // Permet de lire la temperature du capteur

    byte getSeconde(); // Permet de lire les secondes
    void setSeconde(byte seconde); // Permet d'ecrire les secondes

    byte getMinute(); // Permet de lire les mintutes
    void setMinute(byte minute); // Permet d'ecrire les minutes

    byte getHeure(); // Permet de lire l'heure
    void setHeure(byte heure, byte format, QString ampm); // Permet d'ecrire l'heure en 12h et am ou pm ou 24h 

    QString getJour(); // Permet de lire le jour
    void setJour(byte jour); // Permet d'ecrire le jour

    byte getDate(); // Permet de lire la date
    void setDate(byte date); // Permet d'ecrire la date

    byte getMois(); // Permet de lire le mois
    void setMois(byte mois); // Permet d'ecrire le mois

    int getAnnee(); // Permet de lire l'annee
    void setAnnee(byte annee); // Permet d'ecrire l'annee



    byte decToBcd(byte val); // Convertie du decimale en binaire codé decimale
    byte bcdToDec(byte val); // Convertie le binaire codé decimale en decimale

private:
    Ci2c *I2C;

    byte bufferI2C[2];
};

#endif // DS3231_H
