#include "matrice_8x8.h"
#include "array_characters.cpp"

Matrice_8x8::Matrice_8x8(char i2cBus, int address)
{
    HT16K33 = new Ci2c(i2cBus, address);
}

void Matrice_8x8::init()
{
    this->bufferI2c[0] = 0x21;
    HT16K33->writeToI2C(this->bufferI2c, 1);

    this->bufferI2c[0] = 0xE8;
    HT16K33->writeToI2C(this->bufferI2c, 1);

    this->bufferI2c[0] = 0x81;
    HT16K33->writeToI2C(this->bufferI2c, 1);

    clear();
}

void Matrice_8x8::clear()
{
    this->bufferI2c[1] = 0x00;

    for(int i = 0; i <= 0x0F; i++)
    {
        this->bufferI2c[0] = i;

        HT16K33->writeToI2C(this->bufferI2c, 2);

        delayMicroseconds(50);
    }
}

void Matrice_8x8::wirteNumber(int number, int color)
{
    if(color == 1)
    {
        clear();

        for(int i = 0; i < 8; i++)
        {
            this->bufferI2c[0] = colorNumber[0][i];
            this->bufferI2c[1] = arrayOfNumber[number][i];

            HT16K33->writeToI2C(this->bufferI2c, 2);

            delayMicroseconds(50);
        }
    }

    else if(color == 2)
    {
        clear();

        for(int i = 0; i < 8; i++)
        {
            this->bufferI2c[0] = colorNumber[1][i];
            this->bufferI2c[1] = arrayOfNumber[number][i];

            HT16K33->writeToI2C(this->bufferI2c, 2);

            delayMicroseconds(50);
        }
    }

    else if(color == 3)
    {
        clear();

        for(int i = 0; i < 8; i++)
        {
            this->bufferI2c[0] = colorNumber[0][i];
            this->bufferI2c[1] = arrayOfNumber[number][i];
            HT16K33->writeToI2C(this->bufferI2c, 2);

            delayMicroseconds(50);

            this->bufferI2c[0] = colorNumber[1][i];
            this->bufferI2c[1] = arrayOfNumber[number][i];
            HT16K33->writeToI2C(this->bufferI2c, 2);

            delayMicroseconds(50);
        }
    }
    else
    {
        clear();
    }
}

void Matrice_8x8::WriteCharSpecial(char special, int color)
{
    int lenght = sizeof(arrayCharAndSpecial);
    bool trouver = false;
    int i = 0;

    for(i = 0; i < lenght; i++)
    {
        if(arrayCharAndSpecial[i] == special)
        {
            trouver = true;
            break;
        }
    }

    if(trouver)
    {
        if(color == 1)
        {
            clear();

            for(int j = 0; j < 8; j++)
            {
                this->bufferI2c[0] = colorNumber[0][j];
                this->bufferI2c[1] = arrayOfSpecial[i][j];

                HT16K33->writeToI2C(this->bufferI2c, 2);

                delayMicroseconds(50);
            }
        }
        else if(color == 2)
        {
            clear();

            for(int j = 0; j < 8; j++)
            {
                this->bufferI2c[0] = colorNumber[1][j];
                this->bufferI2c[1] = arrayOfSpecial[i][j];

                HT16K33->writeToI2C(this->bufferI2c, 2);

                delayMicroseconds(50);
            }
        }
        else if(color == 3)
        {
            clear();

            for(int j = 0; j < 8; j++)
            {
                this->bufferI2c[0] = colorNumber[0][j];
                this->bufferI2c[1] = arrayOfSpecial[i][j];
                HT16K33->writeToI2C(this->bufferI2c, 2);

                delayMicroseconds(50);

                this->bufferI2c[0] = colorNumber[1][j];
                this->bufferI2c[1] = arrayOfSpecial[i][j];
                HT16K33->writeToI2C(this->bufferI2c, 2);

                delayMicroseconds(50);
            }
        }
        else
        {
            clear();
        }
    }
}
