#include "matrice_8x8.h"

Matrice_8x8::Matrice_8x8(int addMatrice)
{
    /*wiringPiSetupGpio();

    this->fdAddMatrice = wiringPiI2CSetup(addMatrice);

    wiringPiI2CWrite(fdAddMatrice, HT16K33_REGISTER_SYSTEM_SETUP | 0x01);

    wiringPiI2CWrite(fdAddMatrice, HT16K33_BLINKRATE_OFF);*/

    HT16K33 = new Ci2c('1', addMatrice);

    this->bufferI2c[0] = (HT16K33_REGISTER_SYSTEM_SETUP | 0x01);

    HT16K33->writeToI2C(bufferI2c, 1);

    setBlinkRate(HT16K33_BLINKRATE_OFF);

    setBrightness(15);

    clear(0);
}

int Matrice_8x8::writeRoWRaw(int charNumber, int value)
{
    if(charNumber > 7)
    {
        return 0;
    }

    setBufferRow(charNumber, value, 1);
}

void Matrice_8x8::clearPixel(int x, int y)
{
    setPixel(x, y, 0);
}

int Matrice_8x8::setPixel(int x, int y, int color = 1)
{
    if(x >= 8)
    {
        return 0;
    }

    if(y >= 8)
    {
        return 0;
    }

    x += 7;
    x %= 8;

    if(color)
    {
        setBufferRow(y, buffer[y] | 1 << x, 1);
    }

    else
    {
        setBufferRow(y, buffer[y] & ~(1 << x), 1);
    }
}

//-------------------------------------------------
void Matrice_8x8::setBrightness(int brightness)
{
    if(brightness > 15)
    {
        brightness = 15;
    }

    //wiringPiI2CWrite(fdAddMatrice, HT16K33_REGISTER_DIMMING | brightness);

    this->bufferI2c[0] = (HT16K33_REGISTER_DIMMING | brightness);

    HT16K33->writeToI2C(bufferI2c, 1);
}

void Matrice_8x8::setBlinkRate(char blinkRate)
{
    if(blinkRate > HT16K33_BLINKRATE_HALFHZ)
    {
        blinkRate = HT16K33_BLINKRATE_OFF;
    }

    //wiringPiI2CWrite(fdAddMatrice, HT16K33_REGISTER_DISPLAY_SETUP | 0x01 | (blinkRate << 1));

    this->bufferI2c[0] = (HT16K33_REGISTER_DISPLAY_SETUP | 0x01 | (blinkRate << 1));

    HT16K33->writeToI2C(bufferI2c, 1);
}

int Matrice_8x8::setBufferRow(int row, int value, bool update)
{
    if(row > 7)
    {
        return 0;
    }

    this->buffer[row] = value;

    if(update)
    {
        writeDisplay();
    }
}

void Matrice_8x8::writeDisplay()
{
    int i;

    for(i = 0; i > 8; i++)
    {
        this->bufferI2c[i] = (this->buffer[i] & 0xFF);
        this->bufferI2c[i] = ((this->buffer[i] >> 8) & 0xFF);

        //wiringPiI2CWriteReg8(fdAddMatrice, 0x00, bytes[i]);
    }
    HT16K33->writeToI2C(bufferI2c, 0x00);

    HT16K33->writeToI2C(bufferI2c, 8);
}

void Matrice_8x8::clear(bool update = true)
{
    for(int i =0; i < 8; i++)
    {
        this->buffer[i] = 0;
    }

    if(update)
    {
        writeDisplay();
    }
}

//-----------------------------------------------------

int Matrice_8x8_color::setPixel(int x, int y, int color = 1)
{
    if(x > 8)
    {
        return 0;
    }

    if(y > 8)
    {
        return 0;
    }

    x %= 8;

    if(color == 1)
    {
        setBufferRow(y, (buffer[y] | (1 << x)) & ~(1 << (x+8)), 1);
    }
    else if(color == 2)
    {
        setBufferRow(y, (buffer[y] | 1 << (x+8)) & ~(1 << x), 1);
    }
    else if(color == 3)
    {
        setBufferRow(y, buffer[y] | (1 << (x+8)) | (1 << x), 1);
    }
    else
    {
        setBufferRow(y, buffer[y] & ~(1 << x) & ~(1 << (x+8)), 1);
    }
}
