#include "matrice_8x8.h"



Matrice_8x8::Matrice_8x8(int matriceAdd)
{
    this->addMatrice = matriceAdd;
    LEDBackpack = new Matrice_8x8_LEDBackpack(addMatrice);
}

void Matrice_8x8::writeRowRaw(char charNumber, int value)
{
    if(charNumber > 7)
    {
        return;
    }

    LEDBackpack->setBufferRow(charNumber, value, 1);
}

void Matrice_8x8::clearPixel(int x, int y)
{
    setPixel(x, y, 0);
}

void Matrice_8x8::setPixel(int x, int y, int color = 1)
{
    if(x >= 8)
    {
        return;
    }

    if(y >= 8)
    {
        return;
    }

    x += 7;
    x %= 8;

    LEDBackpack->getBuffer(buffer);

    if(color)
    {
        LEDBackpack->setBufferRow(y, buffer[y] | 1 << x, 1);
    }
    else
    {
        LEDBackpack->setBufferRow(y, buffer[y] & ~ (1 << x), 1);
    }
}

void Matrice_8x8::clear()
{
    LEDBackpack->clear(1);
}

void ColorMatrice_8x8::setPixel(int x, int y, bool color = 1)
{
    if(x >= 8)
    {
        return;
    }

    if(y >= 8)
    {
        return;
    }

    x %= 8;

    LEDBackpack->getBuffer(buffer);

    if(color == 1)
    {
        LEDBackpack->setBufferRow(y, (buffer[y] | (1 << x)) & ~(1 << (x+8)), 1);
    }
    else if(color == 2)
    {
        LEDBackpack->setBufferRow(y, (buffer[y] | 1 << (x+8)) & ~(1 << x), 1);
    }
    else if(color == 3)
    {
        LEDBackpack->setBufferRow(y, (buffer[y] | (1 << (x+8)) | 1 << x), 1);
    }
    else
    {
        LEDBackpack->setBufferRow(y, buffer[y] & ~(1 << x) & ~(1 << (x+8)), 1);
    }
}


