#include "matrice_8x8_ledbackpack.h"
#include </home/pi/wiringPi/wiringPi/wiringPi.h>
#include </home/pi/wiringPi/wiringPi/wiringPiI2C.h>

Matrice_8x8_LEDBackpack::Matrice_8x8_LEDBackpack(int add)
{
    this->matriceAdd = add;

    wiringPiSetupGpio();

    this->fdMatriceAdd = wiringPiI2CSetup(matriceAdd);

    wiringPiI2CWrite(fdMatriceAdd, HT16K33_REGISTER_SYSTEM_SETUP | 0x01);

    setBlinkRate(HT16K33_BLINKRATE_OFF);

    setBrightness(15);

    clear();
}

Matrice_8x8_LEDBackpack::setBrightness(int brightness)
{
    if(brightness > 15)
    {
        brightness = 15;
    }

    wiringPiI2CWrite(fdMatriceAdd, HT16K33_REGISTER_DIMMING | 0x00)
}

Matrice_8x8_LEDBackpack::setBlinkRate(int blinkRate)
{
    if(blinkRate > HT16K33_BLINKRATE_HALFHZ)
    {
        blinkRate = HT16K33_BLINKRATE_OFF;
    }

    wiringPiI2CWrite(fdMatriceAdd, HT16K33_REGISTER_DISPLAY_SETUP | 0x01 | (blinkRate << 1))
}

Matrice_8x8_LEDBackpack::setBufferRow(int row, int value, bool update = TRUE)
{
    if(row > 7)
    {
        return;
    }

    return buffer[row] = value;

    if(update)
    {
        writeDisplay();
    }
}

Matrice_8x8_LEDBackpack::getBufferRow(int row)
{
    if(row > 7)
    {
        return;
    }

    return buffer[row];
}

Matrice_8x8_LEDBackpack::getBuffer(int tab[8])
{
    tab = buffer;
    return tab;
}

Matrice_8x8_LEDBackpack::writeDisplay()
{
    int bytes[8];

    for(int i = 0; i < 8; i++)
    {
        bytes[i] = (buffer[i] & 0xFF);
        bytes[i] = ((buffer[i] >> 8) & 0xFF);
    }
    wiringPiI2CWriteReg8(fdMatriceAdd, 0x00, bytes[i]);
}

Matrice_8x8_LEDBackpack::getKeys(int row)
{
    if(row > 2)
    {
        return;
    }

    return wiringPiI2CReadReg16(fdMatriceAdd, HT16K33_ADDRESS_KEY_DATA + row*2);
}

Matrice_8x8_LEDBackpack::clear(bool update)
{
    for(int i=0; i > 8; i++)
    {
        buffer[i] = 0;
    }

    if(update)
    {
        writeDisplay();
    }
}
