#ifndef MATRICE_8X8_LEDBACKPACK_H
#define MATRICE_8X8_LEDBACKPACK_H


// Register

#define HT16K33_REGISTER_DISPLAY_SETUP 0x80
#define HT16K33_REGISTER_SYSTEM_SETUP 0x20
#define HT16K33_REGISTER_DIMMING 0xE0

// Data base address

#define HT16K33_ADDRESS_KEY_DATA 0x40

// Blink rate

#define HT16K33_BLINKRATE_OFF 0x00
#define HT16K33_BLINKRATE_2HZ 0x01
#define HT16K33_BLINKRATE_1HZ 0x02
#define HT16K33_BLINKRATE_HALFHZ 0x03

int buffer[] = {0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000};


class Matrice_8x8_LEDBackpack
{

public:
    Matrice_8x8_LEDBackpack(int add);

    void setBrightness(int brightness);
    void setBlinkRate(int blinkRate);
    void setBufferRow(int row, int value, bool update);
    void getBufferRow(int row);
    void getBuffer(int tab[8]);
    void writeDisplay();
    void getKeys(int row);
    void clear(bool update);


private:
    int matriceAdd;
    int fdMatriceAdd;
};

#endif // MATRICE_8X8_LEDBACKPACK_H
