#ifndef DS3231_H
#define DS3231_H

#include <QString>
#include "ci2c.h"

typedef unsigned char byte;

class DS3231
{
public:
    DS3231(char bus, int addDS3231);

    byte readTemp();

    byte getSeconde();
    void setSeconde(byte seconde);

    byte getMinute();
    void setMinute(byte minute);

    byte getHeure();
    void setHeure(byte heure, byte format, QString ampm);

    QString getJour();
    void setJour(byte jour);

    byte getDate();
    void setDate(byte date);

    byte getMois();
    void setMois(byte mois);

    int getAnnee();
    void setAnnee(byte annee);

private:
    Ci2c *I2C;

    byte bufferI2C[2];

    byte decToBcd(byte val);
    byte bcdToDec(byte val);
};

#endif // DS3231_H
