#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    RTC3231 = new DS3231('1', 0x68);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_btn_get_hour_clicked()
{
    ui->heure->display(RTC3231->getHeure());

    ui->minute->display(RTC3231->getMinute());

    ui->seconde->display(RTC3231->getSeconde());

    ui->label_19->setNum(RTC3231->decToBcd(41));
}

void MainWindow::on_btn_get_date_clicked()
{
    ui->jour->display(RTC3231->getDate());
    ui->mois->display(RTC3231->getMois());
    ui->annee->display(RTC3231->getAnnee());

    ui->lb_jour->setText(RTC3231->getJour());
}

void MainWindow::on_btn_set_clicked()
{
    if(ui->chx_heure->isChecked())
    {
        if(ui->heure_12->isChecked())
        {
            if(ui->AM->isChecked())
            {
                RTC3231->setHeure(ui->set_heure->value(), 12, "am");
            }
            else if(ui->PM->isChecked())
            {
                RTC3231->setHeure(ui->set_heure->value(), 12, "pm");
            }
        }
        else if(ui->heure_24->isChecked())
        {
            RTC3231->setHeure(ui->set_heure->value(), 24, "am");
        }
    }
    else if(ui->chx_minute->isChecked())
    {
        RTC3231->setMinute(ui->set_minute->value());
    }
    else if(ui->chx_seconde->isChecked())
    {
        RTC3231->setSeconde(ui->set_seconde->value());
    }
    else if(ui->chx_date->isChecked())
    {
        RTC3231->setDate(ui->set_date->value());
    }
    else if(ui->chx_jour->isChecked())
    {
        RTC3231->setJour(ui->set_jour->value());
    }
    else if(ui->chx_mois->isChecked())
    {
        RTC3231->setMois(ui->set_mois->value());
    }
    else if(ui->chx_annee->isChecked())
    {
        RTC3231->setAnnee(ui->set_annee->value());
    }

    on_btn_reset_clicked();
}

void MainWindow::on_btn_reset_clicked()
{
    ui->heure_12->setChecked(false);
    ui->heure_24->setChecked(false);
    ui->AM->setChecked(false);
    ui->PM->setChecked(false);

    ui->chx_heure->setChecked(false);
    ui->chx_minute->setChecked(false);
    ui->chx_seconde->setChecked(false);
    ui->chx_date->setChecked(false);
    ui->chx_jour->setChecked(false);
    ui->chx_mois->setChecked(false);
    ui->chx_annee->setChecked(false);

    ui->set_heure->setValue(ui->set_heure->minimum());
    ui->set_minute->setValue(ui->set_minute->minimum());
    ui->set_seconde->setValue(ui->set_seconde->minimum());
    ui->set_date->setValue(ui->set_date->minimum());
    ui->set_jour->setValue(ui->set_jour->minimum());
    ui->set_mois->setValue(ui->set_mois->minimum());
    ui->set_annee->setValue(ui->set_annee->minimum());
}
