#include "i2c_afficheur_4x20.h"

I2C_Afficheur_4x20::I2C_Afficheur_4x20(int lcdAddress)
{
    this->addressLcd = lcdAddress;
    wiringPiSetupGpio();
}

void I2C_Afficheur_4x20::lcdInit(int light)
{
    this->addrI2C = wiringPiI2CSetup(addressLcd);
    this->enLight = light;
    wirteLcd(0x03, 0);
    wirteLcd(0x03, 0);
    wirteLcd(0x03, 0);
    wirteLcd(0x02, 0);
    wirteLcd((LCD_FUNCTIONSET | LCD_2LINE | LCD_5x8DOTS | LCD_4BITMODE),0);
    wirteLcd((LCD_DISPLAYCONTROL | LCD_DISPLAYON),0);
    wirteLcd((LCD_CLEARDISPLAY),0);
    wirteLcd((LCD_ENTRYMODESET | LCD_ENTRYLEFT),0);
    delayMicroseconds(200);
}

void I2C_Afficheur_4x20::wirteLcd(int cmd, int mode)
{
    write4bits(mode | (cmd & 0xF0));
    write4bits(mode | ((cmd << 4) & 0xF0));
}

void I2C_Afficheur_4x20::write4bits(int data)
{
    writeCmd(data | enLight);
    wirteStrob(data);
}

void I2C_Afficheur_4x20::wirteStrob(int data)
{
    writeCmd(data | En | enLight);
    delayMicroseconds(200);
    writeCmd(((data & ~En) | enLight));
    delayMicroseconds(200);
}

void I2C_Afficheur_4x20::writeCmd(int cmd)
{
    wiringPiI2CWrite(addrI2C, cmd);
    delayMicroseconds(200);
}

void I2C_Afficheur_4x20::writeLcdDisplay(string text, int line)
{
    switch(line)
    {
        case 1:
        wirteLcd(0x80, 0);
        break;
        case 2 :
        wirteLcd(0xC0, 0);
        break;
        case 3:
        wirteLcd(0x94, 0);
        break;
        case 4:
        wirteLcd(0xD4, 0);
        break;
    }

    for(int i=0; i < text.length(); i++)
    {
        wirteLcd(int(text[i]), 1);
    }
}

void I2C_Afficheur_4x20::lcdClear()
{
    wirteLcd(LCD_CLEARDISPLAY, 0);
    wirteLcd(LCD_RETURNHOME, 0);
}
