#include "mainwindow.h"
#include "ui_mainwindow.h"
#include "i2c_afficheur_4x20.h"

#define address 0x20
#define LCD_BACKLIGHT 0x08
#define LCD_NOBACKLIGHT 0x00

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    lcd = new I2C_Afficheur_4x20(address);
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::on_PB_sendAll_clicked()
{    
    if(ui->lineEdit_1->text().isEmpty() && ui->lineEdit_2->text().isEmpty() && ui->lineEdit_3->text().isEmpty() && ui->lineEdit_4->text().isEmpty())
    {
        lcd->lcdInit(LCD_NOBACKLIGHT);
    }

    else
    {
        lcd->lcdInit(LCD_BACKLIGHT);

        if(!ui->lineEdit_1->text().isEmpty())
        {
            lcd->writeLcdDisplay(ui->lineEdit_1->text(), 1);
        }

        if(!ui->lineEdit_2->text().isEmpty())
        {
            lcd->writeLcdDisplay(ui->lineEdit_2->text(), 2);
        }

        if(!ui->lineEdit_3->text().isEmpty())
        {
            lcd->writeLcdDisplay(ui->lineEdit_3->text(), 3);
        }

        if(!ui->lineEdit_4->text().isEmpty())
        {
            lcd->writeLcdDisplay(ui->lineEdit_4->text(), 4);
        }
    }
}

void MainWindow::on_PB_clearAll_clicked()
{
    ui->lineEdit_1->clear();
    ui->lineEdit_2->clear();
    ui->lineEdit_3->clear();
    ui->lineEdit_4->clear();
}
