#include "mainwindow.h"
#include "ui_mainwindow.h"

#define adresse 0x20    // adresse de l'afficheur

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    lcd = new I2C_Afficheur_4x20(adresse);  //Crée un nouvelle objet lcd avec comme parametre l'adresse

    lcd->lcdInit(); // Initialisation de l'afficheur
}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::checkBDD()
{
    QString text[4];
    int ligne[4];
    int nb = 0;
    bool ok;

    bdd = QSqlDatabase::addDatabase("QSQLITE");

    bdd.setHostName("localhost");
    bdd.setDatabaseName("/home/pi/bdd/URBACO.db");
    bdd.setPassword("");
    bdd.setUserName("root");

    if(bdd.open())
    {
        this->querydb = new QSqlQuery(bdd);

        if(querydb->exec("SELECT * FROM informations"))
        {
            while(querydb->next())
            {
                if(querydb->value(0).toString().length() > 0)
                {
                    text[nb] = querydb->value(0).toString();
                    ligne[nb] = querydb->value(1).toInt(&ok);
                    nb++;
                }
            }

            if(nb > 0)
            {
                lcd->lcdClear();    // netoie l'afficheur
                lcd->displayOn();   // alume le BACKLIGHT

                for(int i = 0; i < nb; i++)
                {
                    lcd->writeLcdDisplay(text[i], ligne[i]);
                }
            }
            else    // Si il n'y a rien a afficher alors on etein l'afficheur
            {
                lcd->displayOff();  // netoie l'afficheur et eteint le BACKLIGHT
            }

        }
    }
}

void MainWindow::on_pushButton_clicked()
{
    checkBDD();
}


void MainWindow::on_pushButton_2_clicked()
{
    querydb->prepare("UPDATE informations SET texte = :text WHERE ligne = 1");
    querydb->bindValue(":text", "trop de text");
    querydb->exec();
}
