#include "i2c_afficheur_4x20.h"
#include <sqlite3.h>
#include <string>

using namespace std;

#define address 0x20

// Compilation
// g++ -o lcdExample_SQLITE3 lcdExample_SQLITE3.cpp Ci2c.cpp i2c_afficheur_4x20.cpp -l sqlite3

string buffer;
string text[4];
int ligne[4];
string mot;
int d = 0, nb = 1;

static int callback(void *NotUsed, int argc, char **argv, char **azColName)
{
  int i;
  for(i = 0; i < argc; i++)
  {
	  mot = azColName[i];
	  if(mot == "texte")
	  {
		  buffer = (argv[i] ? argv[i] : "NULL");
		  if(buffer.length() > 0)
		  {
			  text[d] = buffer;
			  ligne[d] = nb;
			  d++;
			  nb++;
		  }
		  else
		  {
			  nb++;
		  }
	  }
  }
  return 0;
}

int main(int argc, char **argv)
{
	int rc;
	char *zErrMsg = 0;
	
	sqlite3 *bdd;
	
	I2C_Afficheur_4x20 lcd(address);
	lcd.lcdInit();
	
	rc = sqlite3_open("/home/pi/bdd/URBACO.db", &bdd);
	
	if(rc)
	{
		cerr<<"Imposible d'ouvrire la base de bonne"<<sqlite3_errmsg(bdd)<<endl;
		sqlite3_close(bdd);
		exit(1);
	}
	
	rc = sqlite3_exec(bdd, "SELECT * FROM informations", callback, 0, &zErrMsg);
	
	if(rc != SQLITE_OK)
	{
		cerr<<"SQL erreur"<<zErrMsg<<endl;
		sqlite3_free(zErrMsg);
	}
	
	sqlite3_close(bdd);
	
	lcd.lcdClear();
	lcd.displayOn();
	
	if(d == 0)
	{
		lcd.displayOff();
	}
	else
	{
		for(int i = 0; i < d; i++)
		{
			lcd.writeLcdDisplay(text[i], ligne[i]);
		}
	}
}