<!DOCTYPE html>
<html>
<head>
	<script type="text/javascript" src="highcharts.js"></script>
	<script type="text/javascript" src="jquery.min.js"></script>
<script>
var chart;	


	
	function requestData() {
		$.ajax({
		url: 'high.php',
		
		success: function(point) {
			var series = chart.series[0];
			var shift = series.data.length > 5; 
			var lastIdx = series.data.length > 0 ? series.data.length - 1 : null;

			if (lastIdx != null) {
				console.log("series.data[" + lastIdx + "] : " + series.data[lastIdx].x );
				console.log("point[0] : " + point[0] );
			}

			
			if( lastIdx == null  || (series.data[ lastIdx ].x !== point[0]) ) {
				chart.series[0].addPoint(point, false, shift);
				chart.redraw();
			}

			
			setTimeout(requestData, 10000);    
		},
	
		cache: false,

		complete: function(resultat, statut) {
			
		},

		error: function(exception){alert('Exception:' + exception);}
	});
	}

	$(document).ready(function() {

		chart = new Highcharts.Chart({
		chart: {
		renderTo: 'container',
				type: 'spline',
				events: {
                load: requestData
            }
			},
			title: {
				text: 'Supervision de traffic réseau'
			},
			xAxis: {
				
				labels: {
					formatter: function() {
						return Highcharts.dateFormat('%d-%m-%Y<br/>%H:%M:%S', this.value)
					},
					rotation: 45,
					step: 2,
					align: 'left',
					y: 20
				}
			},
			yAxis: {
				title: {
					text: 'Nombre d\'octets'
				}
			},
			tooltip: {
				formatter: function () {
					return 'Variation du traffic entrant au ' + Highcharts.dateFormat('<b>%d-%m-%Y</b><br/> à <b>%H:%M:%S</b>', this.x) + ' : +' + this.y + ' octets.';
				}
			},
			series: [{
				name: 'Traffic entrant',
				data: []
			}]
		});

	});



	</script>

 </head>
 <body>
 	
 </body>
 </html>